Attribute VB_Name = "mMath"
Option Explicit

'Consts
    Public Const Pi As Single = 3.141593
    Public Const Pi2 As Single = 6.283185
Public Function Distance(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As Long
    'Return delta (distance)
    Distance = Sqr(CDbl(X2 - X1) ^ 2 + CDbl(Y2 - Y1) ^ 2)
End Function

Public Function GetAngle(X1 As Single, Y1 As Single, X2 As Single, Y2 As Single) As Single
    Dim TempX As Single
    Dim TempY As Single
    Dim Angle As Single
    
    'Get difference
    TempX = (X2 - X1)
    TempY = (Y2 - Y1)
    
    'Special case X
    If TempX = 0 Then
        If Y2 > Y1 Then
            Angle = Pi * 0.5
        ElseIf Y2 < Y1 Then
            Angle = Pi * 1.5
        End If
    
        'Return angle
        GetAngle = Angle
        Exit Function
    End If
    
    'Special case Y
    If TempY = 0 Then
        If X2 > X1 Then
            Angle = 0
        ElseIf X2 < X1 Then
            Angle = Pi
        End If
    
        'Return angle
        GetAngle = Angle
        Exit Function
    End If
    
    'Get angle
    Angle = Atn(Abs(TempY) / Abs(TempX))
    
    'Calculate angle
    If TempX < 0 And TempY > 0 Then: Angle = Pi - Angle
    If TempX < 0 And TempY < 0 Then: Angle = Pi + Angle
    If TempX > 0 And TempY < 0 Then: Angle = Pi2 - Angle
    
    'Put in range
    If Angle < 0 Then: Angle = Angle + Pi2
    If Angle > Pi2 Then: Angle = Angle - Pi2
    
    'Return angle
    GetAngle = Angle
End Function
